/*****************************************************************************
 *
 *   (C) Copyright Southsoftware.com, 2005
 *
 *   Title: XMLLNG.H
 *
 *   Version:   1.09
 *
 *   Date:  30-Sep-2005
 *
 *   Author:    Master
 *
 *----------------------------------------------------------------------------
 *
 *   Change log:
 *
 *   DATE        DESCRIPTION
 *   ----------- -------------------------------------------------------------
 *   30-Sep-2005 Original
 *   12-Jan-2009 Last edition
 */

#ifndef XMLLNG_H_
#define XMLLNG_H_ 1

///////////////////////////////////////////////////////////////////////////////
// Decorate exportable functions for Win32 DLL linking.
#if (defined(WIN32) || defined(_WIN32)) && !defined(APPLOC_STATICLIB)
#if defined(APPLOC_BUILDDLL)
#define APPLOC_EXTERN  __declspec(dllexport)
#else
#define APPLOC_EXTERN  __declspec(dllimport)
#endif
#else
#define APPLOC_EXTERN
#endif

///////////////////////////////////////////////////////////////////////////////
#ifdef _MSC_VER
// Assume 4 byte packing throughout.
#include <pshpack4.h>
#elif __BORLANDC__
// Turn off "Structure packing size has changed" warning message.
#pragma option -w-pck
// Assume 4 byte packing throughout.
#pragma option -b.
#include <pshpack4.h>
#pragma option -b
#else
#error You must 4-byte align these structures with the appropriate compiler directives.
#endif

#ifdef __cplusplus
extern "C" {
#endif

///////////////////////////////////////////////////////////////////////////////
enum {
    MULTILANG_AFRIKAANS,           /*  0, Afrikaans */
    MULTILANG_ALBANIAN,            /*  1, Albanian */
    MULTILANG_ARABIC,              /*  2, Arabic */
    MULTILANG_ARMENIAN,            /*  3, Armenian */
    MULTILANG_ASSAMESE,            /*  4, Assamese */
    MULTILANG_AZERI,               /*  5, Azeri */
    MULTILANG_BASQUE,              /*  6, Basque */
    MULTILANG_BELARUSIAN,          /*  7, Belarusian */
    MULTILANG_BENGALI,             /*  8, Bengali */
    MULTILANG_BULGARIAN,           /*  9, Bulgarian */
    MULTILANG_CATALAN,             /* 10, Catalan */
    MULTILANG_CHINESE_SIMPLIFIED,  /* 11, Chinese Simplified */
    MULTILANG_CHINESE_TRADITIONAL, /* 12, Chinese Traditional */
    MULTILANG_CROATIAN,            /* 13, Croatian */
    MULTILANG_CZECH,               /* 14, Czech */
    MULTILANG_DANISH,              /* 15, Danish */
    MULTILANG_DUTCH,               /* 16, Dutch */
    MULTILANG_ENGLISH_US,          /* 17, English US */
    MULTILANG_ENGLISH_UK,          /* 18, English UK */
    MULTILANG_ESTONIAN,            /* 19, Estonian */
    MULTILANG_FAEROESE,            /* 20, Faeroese */
    MULTILANG_FARSI,               /* 21, Farsi */
    MULTILANG_FINNISH,             /* 22, Finnish */
    MULTILANG_FRENCH,              /* 23, French */
    MULTILANG_GEORGIAN,            /* 24, Georgian */
    MULTILANG_GERMAN,              /* 25, German */
    MULTILANG_GREEK,               /* 26, Greek */
    MULTILANG_GUJARATI,            /* 27, Gujarati */
    MULTILANG_HEBREW,              /* 28, Hebrew */
    MULTILANG_HINDI,               /* 29, Hindi */
    MULTILANG_HUNGARIAN,           /* 30, Hungarian */
    MULTILANG_ICELANDIC,           /* 31, Icelandic */
    MULTILANG_INDONESIAN,          /* 32, Indonesian */
    MULTILANG_ITALIAN,             /* 33, Italian */
    MULTILANG_JAPANESE,            /* 34, Japanese */
    MULTILANG_KANNADA,             /* 35, Kannada */
    MULTILANG_KASHMIRI,            /* 36, Kashmiri */
    MULTILANG_KAZAK,               /* 37, Kazak */
    MULTILANG_KONKANI,             /* 38, Konkani */
    MULTILANG_KOREAN,              /* 39, Korean */
    MULTILANG_LATVIAN,             /* 40, Latvian */
    MULTILANG_LITHUANIAN,          /* 41, Lithuanian */
    MULTILANG_MACEDONIAN,          /* 42, Macedonian */
    MULTILANG_MALAY,               /* 43, Malay */
    MULTILANG_MALAYALAM,           /* 44, Malayalam */
    MULTILANG_MANIPURI,            /* 45, Manipuri */
    MULTILANG_MARATHI,             /* 46, Marathi */
    MULTILANG_NEPALI,              /* 47, Nepali */
    MULTILANG_NORWEGIAN,           /* 48, Norwegian */
    MULTILANG_ORIYA,               /* 49, Oriya */
    MULTILANG_POLISH,              /* 50, Polish */
    MULTILANG_PORTUGUESE,          /* 51, Portuguese */
    MULTILANG_PUNJABI,             /* 52, Punjabi */
    MULTILANG_ROMANIAN,            /* 53, Romanian */
    MULTILANG_RUSSIAN,             /* 54, Russian */
    MULTILANG_SANSKRIT,            /* 55, Sanskrit */
    MULTILANG_SERBIAN,             /* 56, Serbian */
    MULTILANG_SINDHI,              /* 57, Sindhi */
    MULTILANG_SLOVAK,              /* 58, Slovak */
    MULTILANG_SLOVENIAN,           /* 59, Slovenian */
    MULTILANG_SPANISH,             /* 60, Spanish */
    MULTILANG_SWAHILI,             /* 61, Swahili */
    MULTILANG_SWEDISH,             /* 62, Swedish */
    MULTILANG_TAMIL,               /* 63, Tamil */
    MULTILANG_TATAR,               /* 64, Tatar */
    MULTILANG_TELUGU,              /* 65, Telugu */
    MULTILANG_THAI,                /* 66, Thai */
    MULTILANG_TURKISH,             /* 67, Turkish */
    MULTILANG_UKRAINIAN,           /* 68, Ukrainian */
    MULTILANG_URDU,                /* 69, Urdu */
    MULTILANG_UZBEK,               /* 70, Uzbek */
    MULTILANG_VIETNAMESE,          /* 71, Vietnamese */
    MULTILANG_MAXLANG              /* 72, Number of supported languages. */
};

///////////////////////////////////////////////////////////////////////////////
#ifndef APPLOC_NOFUNC
APPLOC_EXTERN void __stdcall XMLLangSetKey(TCHAR *lpszRegistrationKey);
APPLOC_EXTERN DWORD __stdcall XMLLangGetVersion(void);
APPLOC_EXTERN bool __stdcall XMLLangGetFileName(int lang, TCHAR *lpszLangFile);
APPLOC_EXTERN int __stdcall XMLLangId2Multilang(unsigned int LangId);
#endif // APPLOC_NOFUNC

///////////////////////////////////////////////////////////////////////////////
typedef struct tagLOADSTRINGS {
    TCHAR *lpszSection;          // the name of the section in the language file
    TCHAR *lpszKeyName;          // the name of the key whose value is to be retrieved
    TCHAR *lpszValidate;         // the validation string
    TCHAR **lpszValue;           // pointer to the retrieved and validated string
    LPARAM lParam;               // application-defined value
} LOADSTRINGS, *LPLOADSTRINGS;

typedef enum {
    LANGFILETYPE_INI,
    LANGFILETYPE_XML
} LANGFILE_TYPE;

typedef enum {
    LANGFILESOURCE_NONE,
    LANGFILESOURCE_MEM,
    LANGFILESOURCE_RES,
    LANGFILESOURCE_FILE
} LANGFILE_SOURCE;

typedef struct tagLOADLANGFILESTRUCT {
    TCHAR *lpFile;
    LANGFILE_SOURCE FileSource;
    LANGFILE_TYPE FileType;
    union {
        DWORD cbFile;
        TCHAR *lpResType;
    } FileExtra;
    TCHAR *lpDefFile;
    LANGFILE_SOURCE DefFileSource;
    LANGFILE_TYPE DefFileType;
    union {
        DWORD cbDefFile;
        TCHAR *lpDefResType;
    } DefFileExtra;
} LOADLANGFILESTRUCT, FAR *LPLOADLANGFILESTRUCT;

#ifndef APPLOC_NOFUNC
APPLOC_EXTERN int __cdecl XMLTemplateString(TCHAR *buffer, int count, TCHAR *format, ...);
APPLOC_EXTERN int __stdcall XMLTemplateStringPtr(TCHAR *buffer, int count, TCHAR *format, va_list argptr);
APPLOC_EXTERN int __stdcall XMLLangLoadStrings(HINSTANCE hInstance, LPLOADSTRINGS lpLoadStrings,
    int nLoadStrings, LPLOADLANGFILESTRUCT lpLoadLangFile);
APPLOC_EXTERN int __stdcall XMLLangFreeStrings(LPLOADSTRINGS lpLoadStrings, int nLoadStrings);
#endif // APPLOC_NOFUNC

///////////////////////////////////////////////////////////////////////////////
typedef unsigned char MULTILANGAVAILABLE[16];

#define MULTILANG_ADDMULTILANG    0
#define MULTILANG_DELETEMULTILANG 1
#define MULTILANG_CHECKMULTILANG  2

#ifndef APPLOC_NOFUNC
APPLOC_EXTERN int __stdcall XMLLangDefMultilang(MULTILANGAVAILABLE LangList, int opcode, int op);
#endif // APPLOC_NOFUNC

#ifdef __cplusplus
}
#endif

#ifdef _MSC_VER 

#include <poppack.h>

#endif // _MSC_VER 

#ifdef __BORLANDC__

#pragma option -b.
#include <poppack.h>
#pragma option -b

#endif // __BORLANDC__

#endif // XMLLNG_H_
