/*****************************************************************************
 *
 *   (C) Copyright Southsoftware.com, 2005
 *
 *   Title: XMLMNU.H
 *
 *   Version:   1.09
 *
 *   Date:  30-Sep-2005
 *
 *   Author:    Master
 *
 *----------------------------------------------------------------------------
 *
 *   Change log:
 *
 *   DATE        DESCRIPTION
 *   ----------- -------------------------------------------------------------
 *   30-Sep-2005 Original
 *   12-Jan-2009 Last edition
 */

#ifndef XMLMNU_H_
#define XMLMNU_H_ 1

///////////////////////////////////////////////////////////////////////////////
// Decorate exportable functions for Win32 DLL linking.
#if (defined(WIN32) || defined(_WIN32)) && !defined(APPLOC_STATICLIB)
#if defined(APPLOC_BUILDDLL)
#define APPLOC_EXTERN  __declspec(dllexport)
#else
#define APPLOC_EXTERN  __declspec(dllimport)
#endif
#else
#define APPLOC_EXTERN
#endif

///////////////////////////////////////////////////////////////////////////////
#ifdef _MSC_VER
// Assume 4 byte packing throughout.
#include <pshpack4.h>
#elif __BORLANDC__
// Turn off "Structure packing size has changed" warning message.
#pragma option -w-pck
// Assume 4 byte packing throughout.
#pragma option -b.
#include <pshpack4.h>
#pragma option -b
#else
#error You must 4-byte align these structures with the appropriate compiler directives.
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
    XMLMNUPARSE_NOERR = 0, // no error
    XMLMNUPARSE_UNCLOSED,  // unclosed tag found
} XMLMNUPARSE_E;

#ifndef APPLOC_NOFUNC
APPLOC_EXTERN int __stdcall XMLTemplateMenuBegin(TCHAR *buffer, int count,
    LPTSTR szTitle, LPTSTR szFlags, DWORD dwId);
APPLOC_EXTERN int __stdcall XMLTemplateMenuItem(TCHAR *buffer, int count,
    LPTSTR szTitle, LPTSTR szFlags, DWORD dwId);
APPLOC_EXTERN int __stdcall XMLTemplateMenuEnd(TCHAR *buffer, int count);
APPLOC_EXTERN HMENU __stdcall XMLCreateMenu(LPCTSTR xmldata, unsigned int xmlsize, XMLMNUPARSE_E *pdwXMLMenuError);
#endif // APPLOC_NOFUNC

#ifdef __cplusplus
}
#endif

#ifdef _MSC_VER 

#include <poppack.h>

#endif // _MSC_VER 

#ifdef __BORLANDC__

#pragma option -b.
#include <poppack.h>
#pragma option -b

#endif // __BORLANDC__

#endif // XMLMNU_H_
