#include <tchar.h>
#include <stdio.h>
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "xmllng.h"
#include "xmldlg.h"
#include "xmlps.h"
#include "sample.h"
#include "dialogs.h"
#include "strtbl.h"
#include "resource.h"

int GetAboutDlgXMLTemplate(TCHAR *xmldata, int xmlsize)
{
    int len = XMLTemplateDlgBegin(xmldata, xmlsize,
        g_strtbl.lpWindowCaption, _T("MS Sans Serif, 10"),
        WS_DLGFRAME | WS_POPUP | WS_BORDER | WS_VISIBLE | WS_CAPTION | WS_SYSMENU | DS_MODALFRAME | DS_3DLOOK | DS_SETFONT,
        NULL, FALSE, FALSE, FALSE, 0, 0, 0, 0);

    len += XMLTemplateDlgRowBegin(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgColBegin(xmldata+len, xmlsize-len,
        1, 0, 0, 0, 14, 4, 14, 4, _T("center"), _T("center"), 0);
    len += XMLTemplateDlgControl(xmldata+len, xmlsize-len,
        _T("STATIC"), g_strtbl.lpWindowCaption, WS_CHILD | WS_VISIBLE,
        NULL, ID_ABOUT_TEXT1, FALSE, FALSE, FALSE, 0, 0, 1, 1);
    len += XMLTemplateDlgColEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgRowEnd(xmldata+len, xmlsize-len);

    len += XMLTemplateDlgRowBegin(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgColBegin(xmldata+len, xmlsize-len,
        0, 0, 0, 0, 14, 4, 14, 4, _T("center"), _T("center"), 0);
    len += XMLTemplateDlgControl(xmldata+len, xmlsize-len,
        _T("STATIC"), _T("Copyright \251 Southsoftware.com"), WS_CHILD | WS_VISIBLE,
        NULL, ID_ABOUT_TEXT2, FALSE, FALSE, FALSE, 0, 0, 1, 1);
    len += XMLTemplateDlgColEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgRowEnd(xmldata+len, xmlsize-len);

    len += XMLTemplateDlgRowBegin(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgColBegin(xmldata+len, xmlsize-len,
        0, 0, 50, 14, 4, 4, 4, 4, _T("center"), _T("center"), 0);
    len += XMLTemplateDlgControl(xmldata+len, xmlsize-len,
        _T("BUTTON"), g_strtbl.lpOK, WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON,
        NULL, IDCANCEL, FALSE, FALSE, FALSE, 0, 0, 1, 1);
    len += XMLTemplateDlgColEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgRowEnd(xmldata+len, xmlsize-len);

    len += XMLTemplateDlgEnd(xmldata+len, xmlsize-len);
    return len;
}

INT_PTR CALLBACK AboutDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        case WM_INITDIALOG:
        {
            return TRUE;
        }

        case WM_COMMAND:
        {
            int cmd = GET_WM_COMMAND_ID(wParam, lParam);
            switch (cmd)
            {
                case IDCANCEL:
                case IDABORT:
                case IDOK:
                {
                    EndDialog(hwndDlg, cmd);
                    break;
                }
            }
            return TRUE;
        }

    }
    return FALSE;
}

LRESULT DisplayAboutDialog(HINSTANCE hInstance, HWND hwnd)
{
    LPTSTR xmldata = NULL;
    int xmlsize = 0;
    LRESULT lResult;
    int len;
    do {
        xmlsize += 4096;
        LPTSTR newxmldata = (LPTSTR)realloc(xmldata, xmlsize*sizeof(TCHAR));
        if (newxmldata)
        {
            xmldata = newxmldata;
        }
        else
        {
            if (xmldata) free(xmldata);
            return IDABORT;
        }
        len = GetAboutDlgXMLTemplate(xmldata, xmlsize);
    } while (len==xmlsize-1);
    lResult = XMLDialogBox(hInstance, hwnd, AboutDlgProc, xmldata, len);
    free(xmldata);
    return lResult;
}

int GetPreferencesDlgXMLTemplate(TCHAR *xmldata, int xmlsize)
{
    int len = XMLTemplateDlgBegin(xmldata, xmlsize,
        g_strtbl.lpOptionsCaption, _T("MS Sans Serif, 10"),
        WS_DLGFRAME | WS_POPUP | WS_BORDER | WS_VISIBLE | WS_CAPTION | WS_SYSMENU | DS_MODALFRAME | DS_3DLOOK | DS_SETFONT,
        NULL, FALSE, FALSE, TRUE, 0, 0, 0, 0);

    len += XMLTemplateDlgRowBegin(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgColBegin(xmldata+len, xmlsize-len,
        3, 0, 0, 0, 8, 4, 8, 4, _T("left"), _T("top"), 0);
    len += XMLTemplateDlgGroupBegin(xmldata+len, xmlsize-len,
        g_strtbl.lpOptionsLanguage, ID_PREF_GROUP);
    len += XMLTemplateDlgRowBegin(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgColBegin(xmldata+len, xmlsize-len,
        0, 0, 0, 0, 8, 4, 8, 4, _T("center"), _T("bottom"), 0);
    len += XMLTemplateDlgControl(xmldata+len, xmlsize-len,
        _T("STATIC"), g_strtbl.lpOptionsSelect, WS_CHILD | WS_VISIBLE,
        NULL, ID_PREF_TEXT, FALSE, FALSE, FALSE, 0, 0, 1, 1);
    len += XMLTemplateDlgColEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgRowEnd(xmldata+len, xmlsize-len);

    len += XMLTemplateDlgRowBegin(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgColBegin(xmldata+len, xmlsize-len,
        0, 0, 70, 10, 8, 4, 8, 8, _T("center"), _T("top"), 0);
    len += XMLTemplateDlgControl(xmldata+len, xmlsize-len,
        _T("COMBOBOX"), _T(""), WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_VSCROLL | CBS_DROPDOWNLIST | CBS_DISABLENOSCROLL,
        NULL, ID_PREF_COMBO, FALSE, TRUE, FALSE, 0, 60, 1, 1);
    len += XMLTemplateDlgColEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgRowEnd(xmldata+len, xmlsize-len);

    len += XMLTemplateDlgGroupEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgColEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgRowEnd(xmldata+len, xmlsize-len);

    len += XMLTemplateDlgRowBegin(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgColBegin(xmldata+len, xmlsize-len,
        0, 0, 50, 14, 4, 4, 4, 4, _T("left"), _T("top"), 0);
    len += XMLTemplateDlgColEnd(xmldata+len, xmlsize-len);

    len += XMLTemplateDlgColBegin(xmldata+len, xmlsize-len,
        0, 0, 50, 14, 4, 4, 4, 4, _T("left"), _T("top"), 0);
    len += XMLTemplateDlgControl(xmldata+len, xmlsize-len,
        _T("BUTTON"), _T("OK"), WS_CHILD | WS_VISIBLE | WS_TABSTOP,
        NULL, IDOK, TRUE, FALSE, FALSE, 0, 0, 1, 1);
    len += XMLTemplateDlgColEnd(xmldata+len, xmlsize-len);

    len += XMLTemplateDlgColBegin(xmldata+len, xmlsize-len,
        0, 0, 50, 14, 4, 4, 4, 4, _T("left"), _T("top"), 0);
    len += XMLTemplateDlgControl(xmldata+len, xmlsize-len,
        _T("BUTTON"), g_strtbl.lpCancel, WS_CHILD | WS_VISIBLE | WS_TABSTOP,
        NULL, IDCANCEL, TRUE, FALSE, FALSE, 0, 0, 1, 1);
    len += XMLTemplateDlgColEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgRowEnd(xmldata+len, xmlsize-len);

    len += XMLTemplateDlgRowBegin(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgColBegin(xmldata+len, xmlsize-len,
        3, 0, 0, 14, 0, 0, 0, 0, _T("left"), _T("top"), 0);
    len += XMLTemplateDlgControl(xmldata+len, xmlsize-len,
        _T("msctls_statusbar32"), _T(""), WS_CHILD | WS_VISIBLE | CCS_NOMOVEY | CCS_NORESIZE,
        NULL, ID_STATUS_BAR, TRUE, FALSE, FALSE, 0, 0, 1, 1);
    len += XMLTemplateDlgColEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgRowEnd(xmldata+len, xmlsize-len);

    len += XMLTemplateDlgEnd(xmldata+len, xmlsize-len);
    return len;
}

INT_PTR CALLBACK PreferencesDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        case WM_INITDIALOG:
        {
            for (int i=0;i<MULTILANG_MAXLANG;i++)
            {
                if (XMLLangDefMultilang(g_DefLangList, MULTILANG_CHECKMULTILANG, i)!=0)
                {
                    LRESULT idx = SendDlgItemMessage(hwndDlg, ID_PREF_COMBO, CB_ADDSTRING, 0, (LPARAM)g_strtbl.LanguageNameTable[i]);
                    SendDlgItemMessage(hwndDlg, ID_PREF_COMBO, CB_SETITEMDATA, idx, (LPARAM)i);
                    if (g_nCurrLang==i) SendDlgItemMessage(hwndDlg, ID_PREF_COMBO, CB_SETCURSEL, idx, 0);
                }
            }
            return TRUE;
        }
        case WM_COMMAND:
        {
            switch (GET_WM_COMMAND_ID(wParam, lParam))
            {
                case IDABORT:
                case IDCANCEL:
                {
                    EndDialog(hwndDlg, GET_WM_COMMAND_ID(wParam, lParam));
                    break;
                }
                case IDOK:
                {
                    LRESULT newlang = SendDlgItemMessage(hwndDlg, ID_PREF_COMBO, CB_GETITEMDATA, 
                    SendDlgItemMessage(hwndDlg, ID_PREF_COMBO, CB_GETCURSEL, 0, 0), 0);
                        SendMessage(GetParent(hwndDlg), WM_COMMAND, MAKEWPARAM(cm_languagefirst+newlang, 0), 0);
                    EndDialog(hwndDlg, GET_WM_COMMAND_ID(wParam, lParam));
                }
            }
            break;
        }
        case DM_XMLDLGWATCHINPUT:
        {
            HWND hwndCursorOver = (HWND)wParam;
            BOOL FromMouse = (BOOL)lParam;

            HWND hwndStatusBar = GetDlgItem(hwndDlg, ID_STATUS_BAR);
            if (hwndStatusBar)
            {
                // status bar window exists
                TCHAR szText[80] = {0};
                UINT iCtrlId = GetDlgCtrlID(hwndCursorOver);
                if (iCtrlId>0)
                {
                    GetItemDescriptionText(FALSE, iCtrlId, szText, lenof(szText));
                }
                if (szText[0] == 0)
                {
                    // unable to determine a valid text, use window caption
                    GetWindowText(hwndDlg, szText, lenof(szText));
                }
                SendMessage(hwndStatusBar, SB_SIMPLE, (WPARAM) (BOOL) TRUE, 0);
                SendMessage(hwndStatusBar, SB_SETTEXT, (WPARAM)255, (LPARAM)szText);
            }

            return 0;
        }

        case WM_MENUSELECT:
        {
            UINT fuFlags =(UINT) HIWORD(wParam);
            UINT uItem = (UINT) LOWORD(wParam);

            HWND hwndStatusBar = GetDlgItem(hwndDlg, ID_STATUS_BAR);
            if (hwndStatusBar)
            {
                // status bar window exists
                TCHAR szText[80] = {0};
                if (fuFlags != 0xFFFF)
                {
                    if ((fuFlags & MF_SYSMENU) == MF_SYSMENU)
                    {
                        // set text for selected system menu item
                        GetItemDescriptionText(TRUE, uItem, szText, lenof(szText));
                    }
                }
                if (szText[0] == 0)
                {
                    // unable to determine a valid text, use window caption
                    GetWindowText(hwndDlg, szText, lenof(szText));
                }
                // set status text
                SendMessage(hwndStatusBar, SB_SIMPLE, (WPARAM) (BOOL) TRUE, 0);
                SendMessage(hwndStatusBar, SB_SETTEXT, (WPARAM)255, (LPARAM)szText);
            }
            return TRUE;
        }
    }
    return FALSE;
}

LRESULT DisplayPreferencesDialog(HINSTANCE hInstance, HWND hwnd)
{
    LPTSTR xmldata = NULL;
    int xmlsize = 0;
    LRESULT lResult;
    int len;
    do {
        xmlsize += 4096;
        LPTSTR newxmldata = (LPTSTR)realloc(xmldata, xmlsize*sizeof(TCHAR));
        if (newxmldata)
        {
            xmldata = newxmldata;
        }
        else
        {
            if (xmldata) free(xmldata);
            return IDABORT;
        }
        len = GetPreferencesDlgXMLTemplate(xmldata, xmlsize);
    } while (len==xmlsize-1);
    lResult = XMLDialogBox(hInstance, hwnd, PreferencesDlgProc, xmldata, len);
    free(xmldata);
    return lResult;
}

int GetSamplePageDlgXMLTemplate(TCHAR *xmldata, int xmlsize, LPTSTR szCaption, LPTSTR szText, int nID)
{
    int len = XMLTemplateDlgBegin(xmldata, xmlsize,
        szCaption, _T("MS Sans Serif, 10"),
        WS_CHILD | WS_VISIBLE | DS_SETFONT,
        NULL, FALSE, FALSE, FALSE, 0, 0, 0, 0);

    len += XMLTemplateDlgRowBegin(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgColBegin(xmldata+len, xmlsize-len,
        3, 0, 50, 50, 8, 4, 8, 4, _T("center"), _T("center"), 0);
    len += XMLTemplateDlgControl(xmldata+len, xmlsize-len,
        _T("STATIC"), szText, WS_VISIBLE | WS_CHILD | SS_NOTIFY,
        NULL, nID, FALSE, FALSE, FALSE, 0, 0, 1, 1);
    len += XMLTemplateDlgColEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateDlgRowEnd(xmldata+len, xmlsize-len);

    len += XMLTemplateDlgEnd(xmldata+len, xmlsize-len);
    return len;
}

INT_PTR CALLBACK SamplePageDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        case WM_INITDIALOG:
        {
            return TRUE;
        }

        case WM_MENUSELECT:
        {
            UINT fuFlags =(UINT) HIWORD(wParam);
            UINT uItem = (UINT) LOWORD(wParam);

            // status bar window is exist
            TCHAR szText[80] = {0};
            if (fuFlags != 0xFFFF)
            {
                if ((fuFlags & MF_SYSMENU) == MF_SYSMENU)
                {
                    // set text for selected system menu item
                    GetItemDescriptionText(TRUE, uItem, szText, lenof(szText));
                }
            }
            if (szText[0] == 0)
            {
                // unable to determine a valid text, use window caption
                GetWindowText(hwndDlg, szText, lenof(szText));
            }
            // set status text
            SendMessage(GetParent(hwndDlg), XMLPSM_SETSTATUSTEXT, 0, (LPARAM)szText);
            return TRUE;
        }

        case WM_NOTIFY:
        {
            LPNMHDR pnmh = (LPNMHDR)lParam;

            if (pnmh->hwndFrom == GetParent(hwndDlg))
            {
                if (pnmh->code == XMLPSN_WATCHINPUT)
                {
                    LPXMLPSNWATCHINPUT lpxmlpswi = (LPXMLPSNWATCHINPUT)lParam;
                    TCHAR szText[80] = {0};
                    switch (lpxmlpswi->cursor)
                    {
                        case XMLPSBTN_BACK: _sntprintf(szText, lenof(szText), g_strtbl.lpDescrBack); break;
                        case XMLPSBTN_NEXT: _sntprintf(szText, lenof(szText), g_strtbl.lpDescrNext); break;
                        case XMLPSBTN_FINISH: _sntprintf(szText, lenof(szText), g_strtbl.lpDescrFinish); break;
                        case XMLPSBTN_OK: _sntprintf(szText, lenof(szText), g_strtbl.lpDescrOK); break;
                        case XMLPSBTN_APPLYNOW: _sntprintf(szText, lenof(szText), g_strtbl.lpDescrApply); break;
                        case XMLPSBTN_CANCEL: _sntprintf(szText, lenof(szText), g_strtbl.lpDescrCancel); break;
                        case XMLPSBTN_HELP: _sntprintf(szText, lenof(szText), g_strtbl.lpDescrHelp); break;
                        case XMLPSBTN_BUYNOW: _sntprintf(szText, lenof(szText), g_strtbl.lpDescrBuyNow); break;
                        case XMLPSBTN_CLOSE: _sntprintf(szText, lenof(szText), g_strtbl.lpDescrClose); break;
                        default: GetWindowText(GetParent(hwndDlg), szText, lenof(szText));
                    }
                    SendMessage(GetParent(hwndDlg), XMLPSM_SETSTATUSTEXT, 0, (LPARAM)szText);
                }
                else if (pnmh->code == XMLPSN_HELP)
                {
                    ShellExecute(hwndDlg, _T("open"), _T("hh.exe"), g_szHelpFileName, NULL, SW_SHOWNORMAL);
                }
            }
            return TRUE;
        }
    }
    return FALSE;
}

void DiaplaySamplePropertyPage(HINSTANCE hInstance, HWND hwnd)
{
    XMLPROPERTYSHEET XMLps;
    ZeroMemory(&XMLps, sizeof(XMLPROPERTYSHEET));
    XMLps.dwFlags = XMLPS_DEFAULT | XMLPS_HASHELP | XMLPS_NOAPPLYNOW | XMLPS_NOBUYNOW | XMLPS_HASSTATUSBAR;
    XMLps.hwndParent = hwnd;
    XMLps.hInstance = hInstance;
    XMLps.hIcon = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(1), IMAGE_ICON, 32, 32, NULL);
    XMLps.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(1), IMAGE_ICON, 16, 16, NULL);
    XMLps.pszCaption = g_strtbl.lpSamplePSCaption;
    XMLps.pszFontInfo = _T("MS Sans Serif, 10");
    XMLps.x = 10; XMLps.y = 10;
    XMLps.cx = 100; XMLps.cy = 100;
    XMLps.propText.pszOK = g_strtbl.lpOK;
    XMLps.propText.pszCancel = g_strtbl.lpCancel;
    XMLps.propText.pszClose = g_strtbl.lpClose;
    XMLps.propText.pszApplyNow = g_strtbl.lpApply;
    XMLps.propText.pszBuyNow = g_strtbl.lpBuyNow;
    XMLps.propText.pszHelp = g_strtbl.lpHelp;
    XMLps.propText.pszBack = g_strtbl.lpBack;
    XMLps.propText.pszNext = g_strtbl.lpNext;
    XMLps.propText.pszFinish = g_strtbl.lpFinish;
    HANDLE hXMLps = XMLPropertySheetCreate(&XMLps);
    if (hXMLps)
    {
        // page 1
        LPTSTR xmldata = NULL;
        int xmlsize = 0;
        int len;
        do {
            xmlsize += 4096;
            LPTSTR newxmldata = (LPTSTR)realloc(xmldata, xmlsize*sizeof(TCHAR));
            if (newxmldata)
            {
                xmldata = newxmldata;
            }
            else
            {
                if (xmldata)
                {
                    free(xmldata);
                    xmldata = NULL;
                }
                break;
            }
            len = GetSamplePageDlgXMLTemplate(xmldata, xmlsize, g_strtbl.lpSamplePSSample1Title, g_strtbl.lpSamplePSSample1Text, ID_PSP_PAGE1);
        } while (len==xmlsize-1);

        if (xmldata)
        {
            XMLPROPERTYSHEETPAGE XMLpsp;
            ZeroMemory(&XMLpsp, sizeof(XMLPROPERTYSHEETPAGE));
            XMLpsp.hInstance = hInstance;
            XMLpsp.lpXMLdata = xmldata;
            XMLpsp.dwXMLsize = len;
            XMLpsp.CheckControlSizeEx = NULL;
            XMLpsp.pszIcon = MAKEINTRESOURCE(1);
            XMLpsp.pfnDlgProc = SamplePageDlgProc;
            XMLpsp.lParam = NULL;
            XMLPropertySheetAdd(hXMLps, &XMLpsp);
            free(xmldata);
        }

        // page 2
        xmldata = NULL;
        xmlsize = 0;
        do {
            xmlsize += 4096;
            LPTSTR newxmldata = (LPTSTR)realloc(xmldata, xmlsize*sizeof(TCHAR));
            if (newxmldata)
            {
                xmldata = newxmldata;
            }
            else
            {
                if (xmldata)
                {
                    free(xmldata);
                    xmldata = NULL;
                }
                break;
            }
            len = GetSamplePageDlgXMLTemplate(xmldata, xmlsize, g_strtbl.lpSamplePSSample2Title, g_strtbl.lpSamplePSSample2Text, ID_PSP_PAGE2);
        } while (len==xmlsize-1);

        if (xmldata)
        {
            XMLPROPERTYSHEETPAGE XMLpsp;
            ZeroMemory(&XMLpsp, sizeof(XMLPROPERTYSHEETPAGE));
            XMLpsp.hInstance = hInstance;
            XMLpsp.lpXMLdata = xmldata;
            XMLpsp.dwXMLsize = len;
            XMLpsp.CheckControlSizeEx = NULL;
            XMLpsp.pszIcon = MAKEINTRESOURCE(1);
            XMLpsp.pfnDlgProc = SamplePageDlgProc;
            XMLpsp.lParam = NULL;
            XMLPropertySheetAdd(hXMLps, &XMLpsp);
            free(xmldata);
        }

        XMLPropertySheetShow(hXMLps, 0);
        XMLPropertySheetFree(hXMLps);
    }
    if (XMLps.hIcon)
        DestroyIcon(XMLps.hIcon);
    if (XMLps.hIconSm)
        DestroyIcon(XMLps.hIconSm);
}

void DiaplaySampleWizard(HINSTANCE hInstance, HWND hwnd)
{
    XMLPROPERTYSHEET XMLps;
    ZeroMemory(&XMLps, sizeof(XMLPROPERTYSHEET));
    XMLps.dwFlags = XMLPS_DEFAULT | XMLPS_HASHELP | XMLPS_NOAPPLYNOW | XMLPS_NOBUYNOW | XMLPS_HASSTATUSBAR | XMLPS_WIZARD | XMLPS_CENTERSCREEN;
    XMLps.hwndParent = hwnd;
    XMLps.hInstance = hInstance;
    XMLps.hIcon = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(1), IMAGE_ICON, 32, 32, NULL);
    XMLps.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(1), IMAGE_ICON, 16, 16, NULL);
    XMLps.pszCaption = g_strtbl.lpSampleWZCaption;
    XMLps.pszFontInfo = _T("MS Sans Serif, 10");
    XMLps.x = 10;
    XMLps.y = 10;
    XMLps.propText.pszOK = g_strtbl.lpOK;
    XMLps.propText.pszCancel = g_strtbl.lpCancel;
    XMLps.propText.pszClose = g_strtbl.lpClose;
    XMLps.propText.pszApplyNow = g_strtbl.lpApply;
    XMLps.propText.pszBuyNow = g_strtbl.lpBuyNow;
    XMLps.propText.pszHelp = g_strtbl.lpHelp;
    XMLps.propText.pszBack = g_strtbl.lpBack;
    XMLps.propText.pszNext = g_strtbl.lpNext;
    XMLps.propText.pszFinish = g_strtbl.lpFinish;
    HANDLE hXMLps = XMLPropertySheetCreate(&XMLps);
    if (hXMLps)
    {
        // page 1
        LPTSTR xmldata = NULL;
        int xmlsize = 0;
        int len;
        do {
            xmlsize += 4096;
            LPTSTR newxmldata = (LPTSTR)realloc(xmldata, xmlsize*sizeof(TCHAR));
            if (newxmldata)
            {
                xmldata = newxmldata;
            }
            else
            {
                if (xmldata)
                {
                    free(xmldata);
                    xmldata = NULL;
                }
                break;
            }
            len = GetSamplePageDlgXMLTemplate(xmldata, xmlsize, _T(""), g_strtbl.lpSampleWZSample1Text, ID_WIZ_PAGE1);
        } while (len==xmlsize-1);

        if (xmldata)
        {
            XMLPROPERTYSHEETPAGE XMLpsp;
            ZeroMemory(&XMLpsp, sizeof(XMLPROPERTYSHEETPAGE));
            XMLpsp.hInstance = hInstance;
            XMLpsp.lpXMLdata = xmldata;
            XMLpsp.dwXMLsize = len;
            XMLpsp.CheckControlSizeEx = NULL;
            XMLpsp.pszIcon = MAKEINTRESOURCE(1);
            XMLpsp.pfnDlgProc = SamplePageDlgProc;
            XMLpsp.lParam = NULL;
            XMLPropertySheetAdd(hXMLps, &XMLpsp);
            free(xmldata);
        }

        // page 2
        xmldata = NULL;
        xmlsize = 0;
        do {
            xmlsize += 4096;
            LPTSTR newxmldata = (LPTSTR)realloc(xmldata, xmlsize*sizeof(TCHAR));
            if (newxmldata)
            {
                xmldata = newxmldata;
            }
            else
            {
                if (xmldata)
                {
                    free(xmldata);
                    xmldata = NULL;
                }
                break;
            }
            len = GetSamplePageDlgXMLTemplate(xmldata, xmlsize, _T(""), g_strtbl.lpSampleWZSample2Text, ID_WIZ_PAGE2);
        } while (len==xmlsize-1);

        if (xmldata)
        {
            XMLPROPERTYSHEETPAGE XMLpsp;
            ZeroMemory(&XMLpsp, sizeof(XMLPROPERTYSHEETPAGE));
            XMLpsp.hInstance = hInstance;
            XMLpsp.lpXMLdata = xmldata;
            XMLpsp.dwXMLsize = len;
            XMLpsp.CheckControlSizeEx = NULL;
            XMLpsp.pszIcon = MAKEINTRESOURCE(1);
            XMLpsp.pfnDlgProc = SamplePageDlgProc;
            XMLpsp.lParam = NULL;
            XMLPropertySheetAdd(hXMLps, &XMLpsp);
            free(xmldata);
        }

        XMLPropertySheetShow(hXMLps, 0);
        XMLPropertySheetFree(hXMLps);
    }
    if (XMLps.hIcon)
        DestroyIcon(XMLps.hIcon);
    if (XMLps.hIconSm)
        DestroyIcon(XMLps.hIconSm);
}
