#include <tchar.h>
#include <stdio.h>
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "xmllng.h"
#include "xmlmnu.h"
#include "xmldlg.h"
#include "xmlps.h"
#include "sample.h"
#include "dialogs.h"
#include "strtbl.h"
#include "resource.h"

TCHAR g_szStartupDirectory[1024] = {0};
TCHAR g_szLangFileName[1024] = {0};
TCHAR g_szHelpFileName[1024] = {0};
HINSTANCE g_hinst;
HWND g_hwndMain;

// List of supported languages.
MULTILANGAVAILABLE g_DefLangList = {0};
int g_nCurrLang = MULTILANG_ENGLISH_US;

///////////////////////////////////////////////////////////////////////////////
// Language strings
STRINGTABLE g_strtbl;

LOADSTRINGS loadstrings[] = {
// Language name string constants
{ _T("Languages"), _T("Afrikaans"), NULL, &g_strtbl.LanguageNameTable[0], NULL },
{ _T("Languages"), _T("Albanian"), NULL, &g_strtbl.LanguageNameTable[1], NULL },
{ _T("Languages"), _T("Arabic"), NULL, &g_strtbl.LanguageNameTable[2], NULL },
{ _T("Languages"), _T("Armenian"), NULL, &g_strtbl.LanguageNameTable[3], NULL },
{ _T("Languages"), _T("Assamese"), NULL, &g_strtbl.LanguageNameTable[4], NULL },
{ _T("Languages"), _T("Azeri"), NULL, &g_strtbl.LanguageNameTable[5], NULL },
{ _T("Languages"), _T("Basque"), NULL, &g_strtbl.LanguageNameTable[6], NULL },
{ _T("Languages"), _T("Belarusian"), NULL, &g_strtbl.LanguageNameTable[7], NULL },
{ _T("Languages"), _T("Bengali"), NULL, &g_strtbl.LanguageNameTable[8], NULL },
{ _T("Languages"), _T("Bulgarian"), NULL, &g_strtbl.LanguageNameTable[9], NULL },
{ _T("Languages"), _T("Catalan"), NULL, &g_strtbl.LanguageNameTable[10], NULL },
{ _T("Languages"), _T("SChinese"), NULL, &g_strtbl.LanguageNameTable[11], NULL },
{ _T("Languages"), _T("TChinese"), NULL, &g_strtbl.LanguageNameTable[12], NULL },
{ _T("Languages"), _T("Croatian"), NULL, &g_strtbl.LanguageNameTable[13], NULL },
{ _T("Languages"), _T("Czech"), NULL, &g_strtbl.LanguageNameTable[14], NULL },
{ _T("Languages"), _T("Danish"), NULL, &g_strtbl.LanguageNameTable[15], NULL },
{ _T("Languages"), _T("Dutch"), NULL, &g_strtbl.LanguageNameTable[16], NULL },
{ _T("Languages"), _T("EnglishUS"), NULL, &g_strtbl.LanguageNameTable[17], NULL },
{ _T("Languages"), _T("EnglishUK"), NULL, &g_strtbl.LanguageNameTable[18], NULL },
{ _T("Languages"), _T("Estonian"), NULL, &g_strtbl.LanguageNameTable[19], NULL },
{ _T("Languages"), _T("Faeroese"), NULL, &g_strtbl.LanguageNameTable[20], NULL },
{ _T("Languages"), _T("Farsi"), NULL, &g_strtbl.LanguageNameTable[21], NULL },
{ _T("Languages"), _T("Finnish"), NULL, &g_strtbl.LanguageNameTable[22], NULL },
{ _T("Languages"), _T("French"), NULL, &g_strtbl.LanguageNameTable[23], NULL },
{ _T("Languages"), _T("Georgian"), NULL, &g_strtbl.LanguageNameTable[24], NULL },
{ _T("Languages"), _T("German"), NULL, &g_strtbl.LanguageNameTable[25], NULL },
{ _T("Languages"), _T("Greek"), NULL, &g_strtbl.LanguageNameTable[26], NULL },
{ _T("Languages"), _T("Gujarati"), NULL, &g_strtbl.LanguageNameTable[27], NULL },
{ _T("Languages"), _T("Hebrew"), NULL, &g_strtbl.LanguageNameTable[28], NULL },
{ _T("Languages"), _T("Hindi"), NULL, &g_strtbl.LanguageNameTable[29], NULL },
{ _T("Languages"), _T("Hungarian"), NULL, &g_strtbl.LanguageNameTable[30], NULL },
{ _T("Languages"), _T("Icelandic"), NULL, &g_strtbl.LanguageNameTable[31], NULL },
{ _T("Languages"), _T("Indonesian"), NULL, &g_strtbl.LanguageNameTable[32], NULL },
{ _T("Languages"), _T("Italian"), NULL, &g_strtbl.LanguageNameTable[33], NULL },
{ _T("Languages"), _T("Japanese"), NULL, &g_strtbl.LanguageNameTable[34], NULL },
{ _T("Languages"), _T("Kannada"), NULL, &g_strtbl.LanguageNameTable[35], NULL },
{ _T("Languages"), _T("Kashmiri"), NULL, &g_strtbl.LanguageNameTable[36], NULL },
{ _T("Languages"), _T("Kazak"), NULL, &g_strtbl.LanguageNameTable[37], NULL },
{ _T("Languages"), _T("Konkani"), NULL, &g_strtbl.LanguageNameTable[38], NULL },
{ _T("Languages"), _T("Korean"), NULL, &g_strtbl.LanguageNameTable[39], NULL },
{ _T("Languages"), _T("Latvian"), NULL, &g_strtbl.LanguageNameTable[40], NULL },
{ _T("Languages"), _T("Lithuanian"), NULL, &g_strtbl.LanguageNameTable[41], NULL },
{ _T("Languages"), _T("Macedonian"), NULL, &g_strtbl.LanguageNameTable[42], NULL },
{ _T("Languages"), _T("Malay"), NULL, &g_strtbl.LanguageNameTable[43], NULL },
{ _T("Languages"), _T("Malayalam"), NULL, &g_strtbl.LanguageNameTable[44], NULL },
{ _T("Languages"), _T("Manipuri"), NULL, &g_strtbl.LanguageNameTable[45], NULL },
{ _T("Languages"), _T("Marathi"), NULL, &g_strtbl.LanguageNameTable[46], NULL },
{ _T("Languages"), _T("Nepali"), NULL, &g_strtbl.LanguageNameTable[47], NULL },
{ _T("Languages"), _T("Norwegian"), NULL, &g_strtbl.LanguageNameTable[48], NULL },
{ _T("Languages"), _T("Oriya"), NULL, &g_strtbl.LanguageNameTable[49], NULL },
{ _T("Languages"), _T("Polish"), NULL, &g_strtbl.LanguageNameTable[50], NULL },
{ _T("Languages"), _T("Portuguese"), NULL, &g_strtbl.LanguageNameTable[51], NULL },
{ _T("Languages"), _T("Punjabi"), NULL, &g_strtbl.LanguageNameTable[52], NULL },
{ _T("Languages"), _T("Romanian"), NULL, &g_strtbl.LanguageNameTable[53], NULL },
{ _T("Languages"), _T("Russian"), NULL, &g_strtbl.LanguageNameTable[54], NULL },
{ _T("Languages"), _T("Sanskrit"), NULL, &g_strtbl.LanguageNameTable[55], NULL },
{ _T("Languages"), _T("Serbian"), NULL, &g_strtbl.LanguageNameTable[56], NULL },
{ _T("Languages"), _T("Sindhi"), NULL, &g_strtbl.LanguageNameTable[57], NULL },
{ _T("Languages"), _T("Slovak"), NULL, &g_strtbl.LanguageNameTable[58], NULL },
{ _T("Languages"), _T("Slovenian"), NULL, &g_strtbl.LanguageNameTable[59], NULL },
{ _T("Languages"), _T("Spanish"), NULL, &g_strtbl.LanguageNameTable[60], NULL },
{ _T("Languages"), _T("Swahili"), NULL, &g_strtbl.LanguageNameTable[61], NULL },
{ _T("Languages"), _T("Swedish"), NULL, &g_strtbl.LanguageNameTable[62], NULL },
{ _T("Languages"), _T("Tamil"), NULL, &g_strtbl.LanguageNameTable[63], NULL },
{ _T("Languages"), _T("Tatar"), NULL, &g_strtbl.LanguageNameTable[64], NULL },
{ _T("Languages"), _T("Telugu"), NULL, &g_strtbl.LanguageNameTable[65], NULL },
{ _T("Languages"), _T("Thai"), NULL, &g_strtbl.LanguageNameTable[66], NULL },
{ _T("Languages"), _T("Turkish"), NULL, &g_strtbl.LanguageNameTable[67], NULL },
{ _T("Languages"), _T("Ukrainian"), NULL, &g_strtbl.LanguageNameTable[68], NULL },
{ _T("Languages"), _T("Urdu"), NULL, &g_strtbl.LanguageNameTable[69], NULL },
{ _T("Languages"), _T("Uzbek"), NULL, &g_strtbl.LanguageNameTable[70], NULL },
{ _T("Languages"), _T("Vietnamese"), NULL, &g_strtbl.LanguageNameTable[71], NULL },

// Buttons
{ _T("Buttons"), _T("OK"), NULL, &g_strtbl.lpOK, NULL },
{ _T("Buttons"), _T("Cancel"), NULL, &g_strtbl.lpCancel, NULL },
{ _T("Buttons"), _T("Close"), NULL, &g_strtbl.lpClose, NULL },
{ _T("Buttons"), _T("Apply"), NULL, &g_strtbl.lpApply, NULL },
{ _T("Buttons"), _T("BuyNow"), NULL, &g_strtbl.lpBuyNow, NULL },
{ _T("Buttons"), _T("Help"), NULL, &g_strtbl.lpHelp, NULL },
{ _T("Buttons"), _T("Back"), NULL, &g_strtbl.lpBack, NULL },
{ _T("Buttons"), _T("Next"), NULL, &g_strtbl.lpNext, NULL },
{ _T("Buttons"), _T("Finish"), NULL, &g_strtbl.lpFinish, NULL },
{ _T("Buttons"), _T("OKDescr"), NULL, &g_strtbl.lpDescrOK, IDOK },
{ _T("Buttons"), _T("CancelDescr"), NULL, &g_strtbl.lpDescrCancel, IDCANCEL },
{ _T("Buttons"), _T("CloseDescr"), NULL, &g_strtbl.lpDescrClose, NULL },
{ _T("Buttons"), _T("ApplyDescr"), NULL, &g_strtbl.lpDescrApply, NULL },
{ _T("Buttons"), _T("BuyNowDescr"), NULL, &g_strtbl.lpDescrBuyNow, NULL },
{ _T("Buttons"), _T("HelpDescr"), NULL, &g_strtbl.lpDescrHelp, NULL },
{ _T("Buttons"), _T("BackDescr"), NULL, &g_strtbl.lpDescrBack, NULL },
{ _T("Buttons"), _T("NextDescr"), NULL, &g_strtbl.lpDescrNext, NULL },
{ _T("Buttons"), _T("FinishDescr"), NULL, &g_strtbl.lpDescrFinish, NULL },

// Menu items
{ _T("Menu"), _T("File"), NULL, &g_strtbl.lpMenuFile, NULL },
{ _T("Menu"), _T("Exit"), NULL, &g_strtbl.lpMenuExit, NULL },
{ _T("Menu"), _T("Sample"), NULL, &g_strtbl.lpMenuSample, NULL },
{ _T("Menu"), _T("SamplePS"), NULL, &g_strtbl.lpMenuSamplePS, NULL },
{ _T("Menu"), _T("SampleWZ"), NULL, &g_strtbl.lpMenuSampleWZ, NULL },
{ _T("Menu"), _T("Options"), NULL, &g_strtbl.lpMenuOptions, NULL },
{ _T("Menu"), _T("Preferences"), NULL, &g_strtbl.lpMenuPreferences, NULL },
{ _T("Menu"), _T("Language"), NULL, &g_strtbl.lpMenuLanguage, NULL },
{ _T("Menu"), _T("Help"), NULL, &g_strtbl.lpMenuHelp, NULL },
{ _T("Menu"), _T("Contents"), NULL, &g_strtbl.lpMenuContents, NULL },
{ _T("Menu"), _T("About"), NULL, &g_strtbl.lpMenuAbout, NULL },

// Menu item descriptions
{ _T("MenuDescription"), _T("System"), NULL, &g_strtbl.lpMenuDescrSystem, NULL },
{ _T("MenuDescription"), _T("Size"), NULL, &g_strtbl.lpMenuDescrSize, NULL },
{ _T("MenuDescription"), _T("Move"), NULL, &g_strtbl.lpMenuDescrMove, NULL },
{ _T("MenuDescription"), _T("Minimize"), NULL, &g_strtbl.lpMenuDescrMinimize, NULL },
{ _T("MenuDescription"), _T("Maximize"), NULL, &g_strtbl.lpMenuDescrMaximize, NULL },
{ _T("MenuDescription"), _T("Close"), NULL, &g_strtbl.lpMenuDescrClose, NULL },
{ _T("MenuDescription"), _T("Restore"), NULL, &g_strtbl.lpMenuDescrRestore, NULL },
{ _T("MenuDescription"), _T("Switch"), NULL, &g_strtbl.lpMenuDescrSwitch, NULL },
{ _T("MenuDescription"), _T("File"), NULL, &g_strtbl.lpMenuDescrFile, NULL },
{ _T("MenuDescription"), _T("Exit"), NULL, &g_strtbl.lpMenuDescrExit, cm_exit },
{ _T("MenuDescription"), _T("Sample"), NULL, &g_strtbl.lpMenuDescrSample, NULL },
{ _T("MenuDescription"), _T("SamplePS"), NULL, &g_strtbl.lpMenuDescrSamplePS, cm_sampleps },
{ _T("MenuDescription"), _T("SampleWZ"), NULL, &g_strtbl.lpMenuDescrSampleWZ, cm_samplewz },
{ _T("MenuDescription"), _T("Options"), NULL, &g_strtbl.lpMenuDescrOptions, NULL },
{ _T("MenuDescription"), _T("Preferences"), NULL, &g_strtbl.lpMenuDescrPreferences, cm_pref },
{ _T("MenuDescription"), _T("Language"), NULL, &g_strtbl.lpMenuDescrLanguage, NULL },
{ _T("MenuDescription"), _T("Help"), NULL, &g_strtbl.lpMenuDescrHelp, NULL },
{ _T("MenuDescription"), _T("Contents"), NULL, &g_strtbl.lpMenuDescrContents, cm_contents },
{ _T("MenuDescription"), _T("About"), NULL, &g_strtbl.lpMenuDescrAbout, cm_about },

// Window caption
{ _T("Window"), _T("Caption"), NULL, &g_strtbl.lpWindowCaption, NULL },

// Options dialog
{ _T("Options"), _T("Caption"), NULL, &g_strtbl.lpOptionsCaption, NULL },
{ _T("Options"), _T("Language"), NULL, &g_strtbl.lpOptionsLanguage, NULL },
{ _T("Options"), _T("Select"), NULL, &g_strtbl.lpOptionsSelect, NULL },
{ _T("Options"), _T("Combo"), NULL, &g_strtbl.lpOptionsCombo, ID_PREF_COMBO },

// Sample property sheet
{ _T("SamplePS"), _T("Caption"), NULL, &g_strtbl.lpSamplePSCaption, NULL },
{ _T("SamplePS"), _T("Sample1Title"), NULL, &g_strtbl.lpSamplePSSample1Title, NULL },
{ _T("SamplePS"), _T("Sample1Text"), NULL, &g_strtbl.lpSamplePSSample1Text, NULL },
{ _T("SamplePS"), _T("Sample2Title"), NULL, &g_strtbl.lpSamplePSSample2Title, NULL },
{ _T("SamplePS"), _T("Sample2Text"), NULL, &g_strtbl.lpSamplePSSample2Text, NULL },

// Sample wizard
{ _T("SampleWZ"), _T("Caption"), NULL, &g_strtbl.lpSampleWZCaption, NULL },
{ _T("SampleWZ"), _T("Sample1Text"), NULL, &g_strtbl.lpSampleWZSample1Text, NULL },
{ _T("SampleWZ"), _T("Sample2Text"), NULL, &g_strtbl.lpSampleWZSample2Text, NULL }
};

///////////////////////////////////////////////////////////////////////////////
// Is file exist
BOOL IsFileExist(LPCTSTR lpszFileName)
{
    HANDLE hSearch;
    WIN32_FIND_DATA FileData;

    hSearch = FindFirstFile(lpszFileName, &FileData);
    if (hSearch != INVALID_HANDLE_VALUE)
    {
        FindClose(hSearch);
        return TRUE;
    }
    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////
// Language initializer
BOOL InitLanguage(void)
{
    // get lang file name
    TCHAR szLangFileName[50];
    XMLLangGetFileName(g_nCurrLang, szLangFileName);
    _stprintf(g_szLangFileName, _T("%s\\%s.lng"), g_szStartupDirectory, szLangFileName);
    if (!IsFileExist(g_szLangFileName))
    {
        _stprintf(g_szLangFileName, _T("%s\\..\\%s.lng"), g_szStartupDirectory, szLangFileName);
        if (g_nCurrLang!=MULTILANG_ENGLISH_US && !IsFileExist(g_szLangFileName))
        {
            // if lang file does not exist, use enlish by default
            XMLLangGetFileName(MULTILANG_ENGLISH_US, g_szLangFileName);
            _stprintf(g_szLangFileName, _T("%s\\%s.lng"), g_szStartupDirectory, szLangFileName);
        }
    }

    // get help file name
    XMLLangGetFileName(g_nCurrLang, szLangFileName);
    _stprintf(g_szHelpFileName, _T("%s\\%s.chm"), g_szStartupDirectory, szLangFileName);
    if (!IsFileExist(g_szHelpFileName))
    {
        _stprintf(g_szHelpFileName, _T("%s\\..\\%s.chm"), g_szStartupDirectory, szLangFileName);
        if (g_nCurrLang!=MULTILANG_ENGLISH_US && !IsFileExist(g_szHelpFileName))
        {
            // if help file does not exist, use enlish help by default
            XMLLangGetFileName(MULTILANG_ENGLISH_US, szLangFileName);
            _stprintf(g_szHelpFileName, _T("%s\\%s.chm"), g_szStartupDirectory, szLangFileName);
        }
    }

    LOADLANGFILESTRUCT LoadLangFile;
    LoadLangFile.lpFile = g_szLangFileName;
    LoadLangFile.FileSource = LANGFILESOURCE_FILE;
    LoadLangFile.FileType = LANGFILETYPE_INI;
    LoadLangFile.lpDefFile = MAKEINTRESOURCE(DEFAULT_LNGTABLE_RESOURCE_ID);
    LoadLangFile.DefFileSource = LANGFILESOURCE_RES;
    LoadLangFile.DefFileType = LANGFILETYPE_INI;
    LoadLangFile.DefFileExtra.lpDefResType = MAKEINTRESOURCE(RT_LNGTABLE);
    XMLLangFreeStrings(loadstrings, sizeof(loadstrings)/sizeof(loadstrings[0]));
    return (XMLLangLoadStrings(g_hinst, loadstrings, sizeof(loadstrings)/sizeof(loadstrings[0]), &LoadLangFile)>0);
}

///////////////////////////////////////////////////////////////////////////////
// Main menu XML template
int GetMainMenuXMLTemplate(TCHAR *xmldata, int xmlsize)
{
    int len = XMLTemplateMenuBegin(xmldata, xmlsize, NULL, NULL, 0);
    len += XMLTemplateMenuBegin(xmldata+len, xmlsize-len, g_strtbl.lpMenuFile, _T("enabled"), 0);
    len += XMLTemplateMenuItem(xmldata+len, xmlsize-len, g_strtbl.lpMenuExit, _T("enabled"), cm_exit);
    len += XMLTemplateMenuEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateMenuBegin(xmldata+len, xmlsize-len, g_strtbl.lpMenuSample, _T("enabled"), 0);
    len += XMLTemplateMenuItem(xmldata+len, xmlsize-len, g_strtbl.lpMenuSamplePS, _T("enabled"), cm_sampleps);
    len += XMLTemplateMenuItem(xmldata+len, xmlsize-len, g_strtbl.lpMenuSampleWZ, _T("enabled"), cm_samplewz);
    len += XMLTemplateMenuEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateMenuBegin(xmldata+len, xmlsize-len, g_strtbl.lpMenuOptions, _T("enabled"), 0);
    len += XMLTemplateMenuItem(xmldata+len, xmlsize-len, g_strtbl.lpMenuPreferences, _T("enabled"), cm_pref);
    len += XMLTemplateMenuItem(xmldata+len, xmlsize-len, NULL, _T("separator"), 0);
    len += XMLTemplateMenuBegin(xmldata+len, xmlsize-len, g_strtbl.lpMenuLanguage, _T("enabled"), 0);
    for (int i=0;i<MULTILANG_MAXLANG;i++)
    {
        if (XMLLangDefMultilang(g_DefLangList, MULTILANG_CHECKMULTILANG, i)!=0)
        {
            len += XMLTemplateMenuItem(xmldata+len, xmlsize-len, g_strtbl.LanguageNameTable[i],
                (g_nCurrLang == i)?_T("checked"):_T("enabled"), cm_languagefirst+i);
        }
    }
    len += XMLTemplateMenuEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateMenuEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateMenuBegin(xmldata+len, xmlsize-len, g_strtbl.lpMenuHelp, _T("enabled"), 0);
    len += XMLTemplateMenuItem(xmldata+len, xmlsize-len, g_strtbl.lpMenuContents, _T("enabled"), cm_contents);
    len += XMLTemplateMenuItem(xmldata+len, xmlsize-len, g_strtbl.lpMenuAbout, _T("enabled"), cm_about);
    len += XMLTemplateMenuEnd(xmldata+len, xmlsize-len);
    len += XMLTemplateMenuEnd(xmldata+len, xmlsize-len);
    return len;
}

///////////////////////////////////////////////////////////////////////////////
// Get description for a menu item.
BOOL GetItemDescriptionText(BOOL sysmenu, UINT id, LPTSTR szText, DWORD ccText)
{
    if (sysmenu)
    {
        switch (id)
        {
            case 0: _sntprintf(szText, ccText, _T("%s"), g_strtbl.lpMenuDescrSystem); return TRUE;
            case 61440: _sntprintf(szText, ccText, _T("%s"), g_strtbl.lpMenuDescrSize); return TRUE;
            case 61456: _sntprintf(szText, ccText, _T("%s"), g_strtbl.lpMenuDescrMove); return TRUE;
            case 61472: _sntprintf(szText, ccText, _T("%s"), g_strtbl.lpMenuDescrMinimize); return TRUE;
            case 61488: _sntprintf(szText, ccText, _T("%s"), g_strtbl.lpMenuDescrMaximize); return TRUE;
            case 61536: _sntprintf(szText, ccText, _T("%s"), g_strtbl.lpMenuDescrClose); return TRUE;
            case 61728: _sntprintf(szText, ccText, _T("%s"), g_strtbl.lpMenuDescrRestore); return TRUE;
            case 61744: _sntprintf(szText, ccText, _T("%s"), g_strtbl.lpMenuDescrSwitch); return TRUE;
            default: return FALSE;
        }
    }
    else
    {
        for(int i=0;i<lenof(loadstrings);i++)
        {
            if ((UINT)loadstrings[i].lParam==id)
            {
                _sntprintf(szText, ccText, _T("%s"), *loadstrings[i].lpszValue);
                return TRUE;
            }
        }
    }
    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////
// Main window proc.
LRESULT CALLBACK MainWindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        case WM_CREATE:
        {
            // Create status bar.
            HWND hwndStatus = CreateStatusWindow(
                WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | CCS_BOTTOM | SBARS_SIZEGRIP | SBT_NOBORDERS,
                _T(""), hwnd, ID_STATUS_BAR);

            break;
        }

        case WM_DESTROY:
        {
            PostQuitMessage(0);
            break;
        }

        case WM_MENUSELECT:
        {
            HMENU hMenu = (HMENU) lParam;
            UINT fuFlags =(UINT) HIWORD(wParam);
            UINT uItem = (UINT) LOWORD(wParam);
            HWND hwndStatusBar = GetDlgItem(hwnd, ID_STATUS_BAR);
            if (hwndStatusBar)
            {
                TCHAR szText[80] = {0};
                if (fuFlags != 0xFFFF)
                {
                    if ((fuFlags & MF_SYSMENU) == MF_SYSMENU)
                    {
                        // Set text for selected system menu item.
                        GetItemDescriptionText(TRUE, uItem, szText, lenof(szText));
                    }
                    else
                    {
                        if ((fuFlags & MF_POPUP) == MF_POPUP)
                        {
                            if ((HMENU)lParam == GetMenu(hwnd))
                            {
                                // One of the popup menus is selected.
                                // uItem specifies an order number of a popup item.
                                switch (uItem)
                                {
                                    case 0: _sntprintf(szText, lenof(szText), _T("%s"), g_strtbl.lpMenuDescrFile); break;
                                    case 1: _sntprintf(szText, lenof(szText), _T("%s"), g_strtbl.lpMenuDescrSample); break;
                                    case 2: _sntprintf(szText, lenof(szText), _T("%s"), g_strtbl.lpMenuDescrOptions); break;
                                    case 3: _sntprintf(szText, lenof(szText), _T("%s"), g_strtbl.lpMenuDescrHelp); break;
                                }
                            }
                            else if ((HMENU)lParam == GetSubMenu(GetMenu(hwnd), 2))
                            {
                                // Language popup menu is selected.
                                _sntprintf(szText, lenof(szText), _T("%s"), g_strtbl.lpMenuDescrLanguage);
                            }
                        }
                        else
                        {
                            if ((HMENU)lParam == GetSubMenu(GetSubMenu(GetMenu(hwnd), 2), 2))
                            {
                                // Language submenu menu is selected.
                                int StrIdx = (uItem-cm_languagefirst);
                                if (StrIdx>=0 && StrIdx<MULTILANG_MAXLANG)
                                {
                                    _sntprintf(szText, lenof(szText), _T("%s"), g_strtbl.LanguageNameTable[StrIdx]);
                                }
                                else
                                {
                                    // Set text for selected menu item.
                                    GetItemDescriptionText(FALSE, uItem, szText, lenof(szText));
                                }
                            }
                            else if ((fuFlags & MF_SEPARATOR) != MF_SEPARATOR)
                            {
                                // Set text for selected menu item.
                                GetItemDescriptionText(FALSE, uItem, szText, lenof(szText));
                            }
                        }
                    }
                }
                SendMessage(hwndStatusBar, SB_SETTEXT, (WPARAM)0, (LPARAM)szText);
            }
            return 0;
        }

        case WM_COMMAND:
        {
            int cmd = GET_WM_COMMAND_ID(wParam, lParam);
            if (cmd>=cm_languagefirst && cmd<=cm_languagefirst+MULTILANG_MAXLANG)
            {
                int nNewLang = (cmd-cm_languagefirst);
                if (nNewLang != g_nCurrLang)
                {
                    DWORD nOldLang = g_nCurrLang;
                    g_nCurrLang = nNewLang;

                    // Load string table
                    if (InitLanguage())
                    {
                        // Change window caption.
                        SetWindowText(hwnd, g_strtbl.lpWindowCaption);

                        // Change menu items.
                        LPTSTR xmldata = NULL;
                        int xmlsize = 0;
                        int len;
                        do {
                            xmlsize += 4096;
                            LPTSTR newxmldata = (LPTSTR)realloc(xmldata, xmlsize*sizeof(TCHAR));
                            if (newxmldata)
                            {
                                xmldata = newxmldata;
                            }
                            else
                            {
                                break;
                            }
                            len = GetMainMenuXMLTemplate(xmldata, xmlsize);
                        } while (len==xmlsize-1);

                        if (xmldata)
                        {
                            HMENU hNewMenu = XMLCreateMenu(xmldata, len, NULL);
                            if (hNewMenu)
                            {
                                HMENU hOldMenu = GetMenu(hwnd);
                                SetMenu(hwnd, hNewMenu);
                                DestroyMenu(hOldMenu);
                            
                            }
                            free(xmldata);
                        }
                    }
                    else
                    {
                        g_nCurrLang = nOldLang;
                    }
                }
            }
            else if (cmd == cm_exit)
            {
                SendMessage(hwnd, WM_SYSCOMMAND, SC_CLOSE, 0L);
            }
            else if (cmd == cm_sampleps)
            {
                DiaplaySamplePropertyPage(g_hinst, hwnd);
            }
            else if (cmd == cm_samplewz)
            {
                DiaplaySampleWizard(g_hinst, hwnd);
            }
            else if (cmd == cm_pref)
            {
                DisplayPreferencesDialog(g_hinst, hwnd);
            }
            else if (cmd == cm_contents)
            {
                ShellExecute(hwnd, _T("open"), _T("hh.exe"), g_szHelpFileName, NULL, SW_SHOWNORMAL);
            }
            else if (cmd == cm_about)
            {
                DisplayAboutDialog(g_hinst, hwnd);
            }
            break;
        }

        default:
            return DefWindowProc(hwnd, uMsg, wParam, lParam); 
    }
    return 0; 
}

///////////////////////////////////////////////////////////////////////////////
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    g_hinst = hInstance;

    // Set registration key
    XMLLangSetKey(NULL);

    // get startup directory from the module name
    GetModuleFileName(g_hinst, g_szStartupDirectory, sizeof(g_szStartupDirectory)/sizeof(g_szStartupDirectory[0]));
    LPTSTR lpSlash = _tcsrchr(g_szStartupDirectory, _T('\\'));
    if (lpSlash) *lpSlash = _T('\0');

    WIN32_FIND_DATA FindFileData;
    LPTSTR lpLanguageDirectory = (LPTSTR)LocalAlloc(LMEM_FIXED, 1024*sizeof(TCHAR));
    if (lpLanguageDirectory)
    {
        int LanguagePass = 2;
        while(LanguagePass>0)
        {
            if (LanguagePass==2) _stprintf(lpLanguageDirectory, _T("%s\\*.lng"), g_szStartupDirectory);
                else _stprintf(lpLanguageDirectory, _T("%s\\..\\*.lng"), g_szStartupDirectory);
            
            HANDLE hSearch = FindFirstFile(lpLanguageDirectory, &FindFileData);
            if (hSearch != INVALID_HANDLE_VALUE) 
            {
                do
                {
                    // Test if found file fits to a language file name.
                    TCHAR szLangFileName[50];
                    for (int i=0;i<MULTILANG_MAXLANG;i++)
                    {
                        XMLLangGetFileName(i, szLangFileName);
                        _tcscat(szLangFileName, _T(".lng"));
                        if (_tcsicmp(szLangFileName, FindFileData.cFileName)==0)
                        {
                            XMLLangDefMultilang(g_DefLangList, MULTILANG_ADDMULTILANG, i);
                            break;
                        }
                    }
                }
                while (FindNextFile(hSearch, &FindFileData));

                // Close the search handle. 
                FindClose(hSearch);
            }
            LanguagePass--;
        }
        LocalFree(lpLanguageDirectory);
    }

    // try to set user language
    g_nCurrLang = XMLLangId2Multilang(GetUserDefaultLangID());
    if (XMLLangDefMultilang(g_DefLangList, MULTILANG_CHECKMULTILANG, g_nCurrLang)==0)
    {
        // user language is not supported, use english
        g_nCurrLang = MULTILANG_ENGLISH_US;
    }

    InitCommonControls();

    if (InitLanguage())
    {
        // create main window class
        WNDCLASSEX wndclass;
        wndclass.cbSize=sizeof(WNDCLASSEX);
        wndclass.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
        wndclass.lpfnWndProc = MainWindowProc;
        wndclass.cbClsExtra = 0;
        wndclass.cbWndExtra = 0;
        wndclass.hInstance = g_hinst;
        wndclass.hIcon = NULL;
        wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
        wndclass.hbrBackground = (HBRUSH) (COLOR_3DFACE+1);
        wndclass.lpszMenuName = NULL;
        wndclass.lpszClassName = _T("SAMPLE_XML_DIALOGS_WINDOW_CLASS_NAME");
        wndclass.hIconSm = NULL;
        RegisterClassEx(&wndclass);

        HMENU hMenu = NULL;
        LPTSTR xmldata = NULL;
        int xmlsize = 0;
        int len;
        do {
            xmlsize += 4096;
            LPTSTR newxmldata = (LPTSTR)realloc(xmldata, xmlsize*sizeof(TCHAR));
            if (newxmldata)
            {
                xmldata = newxmldata;
            }
            else
            {
                if (xmldata)
                {
                    free(xmldata);
                    xmldata = NULL;
                }
                break;
            }
            len = GetMainMenuXMLTemplate(xmldata, xmlsize);
        } while (len==xmlsize-1);

        if (xmldata)
        {
            hMenu = XMLCreateMenu(xmldata, len, NULL);
            free(xmldata);
        }

        // create main window
        g_hwndMain = CreateWindowEx(
            NULL,
            _T("SAMPLE_XML_DIALOGS_WINDOW_CLASS_NAME"), // window class name
            g_strtbl.lpWindowCaption, // window caption
            WS_POPUP | WS_VISIBLE | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_THICKFRAME | WS_CAPTION, // window style
            100, // initial x position
            100, // initial y position
            300, // initial x size
            300, // initial y size
            NULL, // parent window handle
            hMenu, // window menu handle
            g_hinst, // program instance handle
            NULL
        );

        if (g_hwndMain)
        {
            ShowWindow(g_hwndMain, nCmdShow);
            UpdateWindow(g_hwndMain);
            SetForegroundWindow(g_hwndMain);

            MSG msg;
            while (GetMessage(&msg, NULL, 0, 0))
            {
                if (g_hwndMain == 0 || !IsDialogMessage(g_hwndMain, &msg))
                {
                    TranslateMessage(&msg);
                    DispatchMessage(&msg);
                }
            }
        }
    } else MessageBox(NULL, _T("Unable to load language strings. Reinstalling the application may fix this problem."), _T("Sample XML dialogs"), MB_ICONSTOP | MB_OK);
    XMLLangFreeStrings(loadstrings, sizeof(loadstrings)/sizeof(loadstrings[0]));
    return 0;
}
